/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.ScriptParamDefRecord;

import java.util.Arrays;
import java.util.List;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class ScriptParamDef extends TableImpl<ScriptParamDefRecord> {

	private static final long serialVersionUID = 2108042319;

	/**
	 * The reference instance of <code>public.script_param_def</code>
	 */
	public static final ScriptParamDef SCRIPT_PARAM_DEF = new ScriptParamDef();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<ScriptParamDefRecord> getRecordType() {
		return ScriptParamDefRecord.class;
	}

	/**
	 * The column <code>public.script_param_def.id</code>.
	 */
	public final TableField<ScriptParamDefRecord, Long> ID = createField("id", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.script_param_def.script_def_id</code>.
	 */
	public final TableField<ScriptParamDefRecord, Long> SCRIPT_DEF_ID = createField("script_def_id", org.jooq.impl.SQLDataType.BIGINT.nullable(false), this, "");

	/**
	 * The column <code>public.script_param_def.name</code>.
	 */
	public final TableField<ScriptParamDefRecord, String> NAME = createField("name", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "");

	/**
	 * The column <code>public.script_param_def.type</code>.
	 */
	public final TableField<ScriptParamDefRecord, String> TYPE = createField("type", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "");

	/**
	 * The column <code>public.script_param_def.description</code>.
	 */
	public final TableField<ScriptParamDefRecord, String> DESCRIPTION = createField("description", org.jooq.impl.SQLDataType.CLOB, this, "");

	/**
	 * The column <code>public.script_param_def.array</code>.
	 */
	public final TableField<ScriptParamDefRecord, Boolean> ARRAY = createField("array", org.jooq.impl.SQLDataType.BOOLEAN.defaulted(true), this, "");

	/**
	 * The column <code>public.script_param_def.method</code>.
	 */
	public final TableField<ScriptParamDefRecord, String> METHOD = createField("method", org.jooq.impl.SQLDataType.CLOB, this, "");

	/**
	 * The column <code>public.script_param_def.default_value</code>.
	 */
	public final TableField<ScriptParamDefRecord, byte[]> DEFAULT_VALUE = createField("default_value", org.jooq.impl.SQLDataType.BLOB.nullable(false), this, "");

	/**
	 * Create a <code>public.script_param_def</code> table reference
	 */
	public ScriptParamDef() {
		this("script_param_def", null);
	}

	/**
	 * Create an aliased <code>public.script_param_def</code> table reference
	 */
	public ScriptParamDef(String alias) {
		this(alias, SCRIPT_PARAM_DEF);
	}

	private ScriptParamDef(String alias, Table<ScriptParamDefRecord> aliased) {
		this(alias, aliased, null);
	}

	private ScriptParamDef(String alias, Table<ScriptParamDefRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Identity<ScriptParamDefRecord, Long> getIdentity() {
		return Keys.IDENTITY_SCRIPT_PARAM_DEF;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<ScriptParamDefRecord> getPrimaryKey() {
		return Keys.SCRIPT_PARAMETER_DEFINITION_PKEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<ScriptParamDefRecord>> getKeys() {
		return Arrays.<UniqueKey<ScriptParamDefRecord>>asList(Keys.SCRIPT_PARAMETER_DEFINITION_PKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<ForeignKey<ScriptParamDefRecord, ?>> getReferences() {
		return Arrays.<ForeignKey<ScriptParamDefRecord, ?>>asList(Keys.SCRIPT_PARAM_DEF__SCRIPT_PARAM_DEF_SCRIPT_DEF_ID_FKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ScriptParamDef as(String alias) {
		return new ScriptParamDef(alias, this);
	}

	/**
	 * Rename this table
	 */
	public ScriptParamDef rename(String name) {
		return new ScriptParamDef(name, null);
	}
}
